unit uPaint2Obj;

{$MODE Delphi}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,StdCtrls,upaint2ObjBase,tools,uScrollbalken;

type
  TRectEck = class(TPaint2BasesObj)
  private
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);override;
    procedure ShiftFunc(x,y:Integer);override;
  end;

  TKreis = class(TPaint2BasesObj)
  private
    fRadios:Integer;
    function GetRadios:Integer;
    procedure SetRadios(value:Integer);
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);override;
    procedure ShiftFunc(x,y:Integer);override;
    procedure Save(Stringlist:TStringList;stream:TStream);
    procedure load(Stringlist:TStringList;stream:TStream);
  published
    property Radios:Integer read GetRadios write SetRadios;
  end;

  TLine = class(TPaint2BasesObj)
  private
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);override;
    procedure ShiftFunc(x,y:Integer);override;
  end;

  Tbg = class(TPaint2BasesObj)
  private
  public
    bild:TBitmap;
    ok:Boolean;

    constructor Create(value:TBitMap;aOwner:TComponent);
    procedure Draw(var buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);override;
    procedure SetMod(Value:Boolean);override;
    procedure ShiftFunc(x,y:Integer);override;
  end;
  
  troundrec = class(TPaint2BasesObj)
  private
    frx,fry:Integer;
    procedure SetR(index,value:Integer);
    function GetR(index:Integer):Integer;
  public
    constructor Create(value:TBitMap);
    procedure Draw(var buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);override;
    procedure Save(Stringlist:TStringList;stream:TStream);
    procedure Load(Stringlist:TStringList;stream:TStream);
    procedure ShiftFunc(x,y:Integer);override;
  published
    property Rx:Integer index  1 read getr write setR;
    property Ry:Integer index  2 read getr write setR;

  end;

implementation


constructor TRectEck.Create(value:TBitMap);
begin
  Name:='Rechteck';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  inherited Create(Value);
end;

procedure TRectEck.Draw(buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);
var
  sx,sy:Integer;
begin
  inherited;
  buffer.Canvas.Rectangle(position.x,position.y,size.x,size.y);

  Buffer.Canvas.Pen:=oldpen;
  Buffer.Canvas.Brush:=oldbrush;
end;

procedure TRectEck.ShiftFunc(x,y:Integer);
var
  p1,p2,s,s1,h:Integer;
begin
{  p1:=x - position.x; p2:=y - position.y;
  
  if p1 <= p2 then begin // es ist vertikal
    Screen.Forms[0].caption:='+';
    h:=(p2*4);
//
//    h:=;
  end
  else begin // es ist horizontal
    Screen.Forms[0].caption:='-';
   h:=y;
   end;}

  size:=pointTOTPoint2(x,y)
end; // ShiftFunc

constructor TKreis.Create(value:TBitMap);
begin
  Name:='Kreis';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  inherited Create(Value);
end;

procedure TKreis.Draw(buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);
begin
  inherited;
  if (x > -1) and (y > -1) then
    buffer.Canvas.Ellipse(x,y,size.x,size.y)
  else
    buffer.Canvas.Ellipse(position.x,position.y,size.x,size.y);
    
  Buffer.Canvas.Pen:=oldpen;

  Buffer.Canvas.Brush:=oldbrush;
end;

function TKreis.GetRadios:Integer;
begin
  result:=fRadios;
end;

procedure TKreis.SetRadios(value:Integer);
begin
  fRadios:=Value;
end;

procedure TKreis.Save(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
    Stringlist.add('kreis.radios = ' + IntTostr(Radios));
  end;

  if stream <> NIL then begin
  end;

end;

procedure TKreis.load(Stringlist:TStringList;stream:TStream);
var
  index:Integer;
  str:String;
begin
  inherited;
  if Stringlist <> NIL then begin
    index:=GetStringListIndex('kreis.radios',StringList);
    if index > -1 then begin
      Radios:=StrToInt(GetToken(Stringlist[index],'=',2));
    end;
  end;

  if stream <> NIL then begin
  end;
end;


procedure TKreis.ShiftFunc(x,y:Integer);
begin
end; // ShiftFunc

constructor TLine.Create(value:TBitMap);
begin
  Name:='Line';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  inherited Create(Value);

end;

procedure TLine.Draw(buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);
begin
  inherited;
  if (x > -1) and (y > -1) then
    buffer.Canvas.moveTo(x,y)
  else
    buffer.Canvas.moveTo(position.x,position.y);

  buffer.Canvas.LineTo(size.x,size.y);
//  if fissel = true then
    
  Buffer.Canvas.Pen:=oldpen;
  Buffer.Canvas.Brush:=oldbrush;

end;

procedure TLine.ShiftFunc(x,y:Integer);
begin
end; // ShiftFunc

constructor Tbg.Create(value:TBitMap;aOwner:TComponent);
begin
  inherited Create(Value);
  Name:='Backgrund';
//  fpen:=TPen.Create; fBrush:=TBrush.Create;
  fest:=True;
//  bild:=TBitmap.Create;
  ok:=False;
end; // Create

procedure TBG.ShiftFunc(x,y:Integer);
begin
end; // ShiftFunc

procedure Tbg.Draw(buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);
begin
  inherited;
//  if bild
  buffer.Canvas.Rectangle(x,y,w,h);
  Buffer.Canvas.Pen:=oldpen;Buffer.Canvas.Brush:=oldbrush;
end;

procedure Tbg.SetMod(Value:Boolean);
begin
  fmod:=Value;
{  if value = True then begin
    fmod:=False;
    if bild = NIL then bild:=TBitmap.Create;
    bild.Width:=Size.x; bild.Height:=Size.y;
    Draw(bild,true,0,0);
    ok:=true;
  end;}

end;


constructor troundrec.Create(value:TBitMap);
begin
  Name:='Abgerundesviereck';
  fest:=False;
  frx:=20; fry:=20;
  inherited Create(Value);
end;

procedure troundrec.Draw(var buffer:TBitMap;fissel:Boolean;x,y,w,h:Integer);
begin
  inherited;
  if (x > -1) and (y > -1) then
    buffer.Canvas.RoundRect(x,y,size.x,size.y,frx,fry)
  else
    buffer.Canvas.RoundRect(position.x,position.y,size.x,size.y,frx,fry)
end;

procedure troundrec.SetR(index,value:Integer);
begin
  if index = 1 then frx:=value;
  if index = 2 then fry:=value;
end;

function troundrec.GetR(index:Integer):Integer;
begin
  if index = 1 then result:=frx;
  if index = 2 then result:=fry;

end;

procedure troundrec.Save(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
    Stringlist.add('roundrec.r = ' + IntTostr(frx) + ',' + intTostr(fry));
  end;

  if stream <> NIL then begin
  end;
end;

procedure troundrec.load(Stringlist:TStringList;stream:TStream);
var
  index:Integer;
  str:String;
begin
  inherited;
  if Stringlist <> NIL then begin
    index:=GetStringListIndex('roundrec.r',StringList);
    if index > -1 then begin
      str:=GetToken(Stringlist[index],'=',2);
      rx:=StrToInt(GetToken(str,',',1));
      ry:=StrToInt(GetToken(str,',',2));
    end;

  end;

  if stream <> NIL then begin
  end;
end;

procedure troundrec
.ShiftFunc(x,y:Integer);
begin
end; // ShiftFunc

end.
