unit uPaint2ObjList;

{$MODE Delphi}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,Contnrs,uPaint2Obj,upaint2ObjBase,RTTIGrids;

type
  tonAddObj = procedure(obj:TPaint2Obj) of Object;
  TonChangeObj = procedure(Newobj:TPaint2Obj) of object;
  tOnSizeChange = procedure(NW,NH:integer) of object;
  tDeleteObj = procedure(index:Integer) of object;


  TPaint2ObjList = class
  private
    fVt:TTIPropertyGrid;
    fPaintBox:TPaintbox;
//    fHandel:HDC;
    fitemindex:Integer;
    procedure SetIndex(Value:Integer);
    function GetIndex:Integer;
  public
    B,F,P,S,pt:TStringList;
    objList:TObjectList;
    Buffer:TBitMap;
    bufferw,bufferh:Integer;
    PointDraqIndex:Integer;
    objSel:TPaint2Obj;
    onAddObj:tonAddObj;
    onChangeobj:TonChangeObj;
    onChangeSize:tOnSizeChange;
    onDeleteObj:tDeleteObj;
    function GetSellObj:Integer;
    function GetItemIndex(x,y:Integer;Obj:TObjectList;state:TShiftState):Integer;
    constructor Create(vt:TTIPropertyGrid;w,h:Integer;{destCanvas:TCanvas;}PaintBox:TPaintBox);
    procedure AddObj(objTyp:Integer; x,y,w,h:Integer;Name:String);
    procedure Clear;
    procedure DrawObj;
    procedure Flip;
    property ItemIndex:Integer read GetIndex write Setindex;
    function GetName(objtyp:Integer):Integer;
    procedure UpdatetDataList(Index:Integer);
    procedure SetBufferSize(w,h:Integer);
    procedure ClearSel(Value:Boolean);
    procedure DelSel;

  end;

implementation

function TPaint2ObjList.GetSellObj:Integer;
var
  i,z:Integer;
begin
  z:=0;
  for i:=0 to objList.Count-1  do begin
    if TPaint2obj(objlist.items[i]).sel then
      inc(z)
  end;
  result:=z;
end;

procedure TPaint2ObjList.DelSel;
var
  i:Integer;
begin
  for i:=objList.Count-1 downto 0 do begin
    if TPaint2Obj(objList.items[i]).Sel then begin
      objList.Delete(i);
      if Assigned(onDeleteObj) then onDeleteObj(i);
    end;
  end;
  DrawObj;
end; // DelSel

procedure TPaint2ObjList.SetBufferSize(w,h:Integer);
begin
  if self <> NIL then begin
    Buffer.Width:=w;
    Buffer.Height:=h;
    BufferW:=w;
    BufferH:=h;
    DrawObj;
    if Assigned(onChangeSize) then onChangeSize(w,h);
  end;
end;

procedure TPaint2ObjList.ClearSel(Value:Boolean);
var
  i:Integer;
begin
  for i:=0 to objList.Count-1 do begin
    TPaint2Obj(objlist.items[i]).Sel:=Value;
  end;
end; // ClearSel

function TPaint2ObjList.GetName(objtyp:Integer):Integer;
var
  i,z:Integer;
begin
  z:=0;
  for i:=0 to objList.count -1 do begin
    if TPaint2Obj(objlist.items[i]).Typ = objtyp then
      inc(z)
  end;
  result:=z+1;
end; // GetName

procedure TPaint2ObjList.UpdatetDataList(Index:Integer);
begin
  fvt.TIObject:=TPaint2Obj(objlist.items[Index]);
end; // UpdatetDataList

procedure TPaint2ObjList.SetIndex(Value:Integer);
begin
  fitemindex:=Value;
//  if value > -1 then begin
//    objSel:=TPaint2Obj(objList.Items[value]);
//  end;
end; // SetItemIndex

function TPaint2ObjList.GetIndex:Integer;
begin
  result:=fItemindex;
end; // GetItemIndex

procedure TPaint2ObjList.Clear;
begin
  Buffer.Width:=1; Buffer.Height:=1;
  Buffer.Width:=bufferw; Buffer.Height:=bufferH;
end;


function TPaint2ObjList.GetItemIndex(x,y:Integer;Obj:TObjectList;state:TShiftState):Integer;
var
  i,pIndex:Integer;
  r:TRect;
begin
  pIndex:=-1;

  for i:=0 to obj.count-1 do begin
    with TPaint2Obj(obj.items[i]) do begin
     if obj.Items[i] is TLine = false then begin
        r.left:=position.x; r.top:=position.y; r.Right:=size.x;r.Bottom:=size.y;
        if PtInRect(r,point(x,y)) = true then
          pindex:=i;
     end
     else begin
     end;
    end;
  end;
  if pindex > -1 then
  objSel:=TPaint2Obj(obj.items[pindex]);
  result:=Pindex;
  if pindex > -1 then begin
    fvt.Clear;
    if ssshift in state then
    TPaint2Obj(obj.items[pindex]).Sel:=True;
  end
  else begin
    ClearSel(False);
    objsel:=nil;
  end;
end;

procedure TPaint2ObjList.AddObj(objTyp:Integer; x,y,w,h:Integer;Name:String);
var
  obj:TPaint2Obj;
begin
  if objTyp = alt_Vireck then obj:=TRectEck.Create(Buffer);
  if objTyp = alt_kreis then obj:=TKreis.Create(Buffer);
  if objTyp = alt_Line then obj:=TLine.Create(Buffer);

  obj.Position:=pointTOTPoint2(x,y);
  obj.Size:=pointTOTPoint2(w,h);
  obj.Typ:=objTyp;
  obj.Brush.Color:=clRed;
  if objtyp = alt_line then
    obj.PointsModus:=1
  else
    obj.PointsModus:=0;
    
  if Name = '' then
    obj.Name:=obj.Name + IntTostr(GetName(obj.typ));
  obj.Visible:=True;
  obj.onChangeobj:=onChangeobj;
  obj.Sel:=True;
  itemindex:=objList.Add(obj);
  objSel:=TPaint2Obj(objList.items[itemindex]);
  if itemindex > -1 then begin
//    fvt.Clear;
  UpdatetDataList(itemindex);
//    TPaint2Obj(objList.items[itemindex]).CreateDatenList;
  end;

  if Assigned(onAddObj) then onAddObj(obj);

  obj.pointDrawDown:=2;


  if Assigned(onChangeobj) then
  onChangeobj(obj);
end;

constructor TPaint2ObjList.Create(vt:TTIPropertyGrid;w,h:Integer;{DESTCanvas:TCanvas;}PaintBox:TPaintBox);
begin
  objList:=TObjectList.Create;
  itemindex:=-1;
//  fHandel:=DESTCanvas;
  fPaintBox:=PaintBox;
  Buffer:=TBitMap.Create;
  SetBufferSize(w,h);
  buffer.Width:=w; buffer.Height:=h;
  bufferw:=w; bufferh:=h;

  fVt:=vt;

  objList:=TObjectList.Create;
  B:=TStringlist.Create;
  b.add('Color = Color = clBlack');
  b.add('Style = BrushList = 0');

  P:=TStringlist.Create;
  P.add('Color = Color = clRed');
  P.add('Style = PenList = 0');
  P.add('Widht = Int = 1');

  f:=TStringlist.Create;
  f.add('Name = FontList');
  f.add('Style = FontStyle');
  f.add('Size = Int = 0');
  f.add('Color = Color = clRed');

  s:=TStringlist.Create;
  s.add('Fett = Boolean = False');
  s.add('Kusiv = Boolean = False');
  s.add('Durchgesitchen = Boolean = False');
  s.add('Unterstrichen = Boolean = False');

  pt:=TStringlist.Create;
  pt.add('x = Int = 0');
  pt.add('y = Int = 0');
end; // Create

procedure TPaint2ObjList.DrawObj;
var
  i,px,py,sx,sy:Integer;
begin
  Clear;
  for i:=0 to objList.count -1 do begin
    with TPaint2Obj(objList.Items[i]) do begin
      if Visible = True then begin
        if ((PointsModus = 0) and ((Sel = true) or (i = itemindex))) then begin
          Buffer.Canvas.Pen.Style:=psDash;
          if i = itemindex then
            Buffer.Canvas.Pen.Color:=clLime
          else
            Buffer.Canvas.Pen.Color:=clRed;
    //      if TPaint2Obj(objList.Items[i])  is TLine = false then
          Buffer.Canvas.brush.Style:=bsClear;
          if position.x < size.x  then
            px:=Position.x-2
          else
            px:=Position.x+2;

          if position.y < size.y then
            py:=position.y-2
          else
            py:=position.y+2;

          if position.X < size.X   then
            sx:=size.x+2
          else
            sx:=size.x-2;

          if  position.Y < size.Y  then
            sy:=size.y+2
          else
            sy:=size.y-2;          
          Buffer.Canvas.Rectangle(px,py,sx,sy);
        end;
        Draw(buffer,i = itemindex);
      end;
    end;
  end;
  flip;

end;

procedure TPaint2ObjList.Flip;
begin
  BitBlt(fPaintBox.Canvas.Handle,0,0,bufferw,bufferh,buffer.canvas.Handle,0,0,fPaintBox.Canvas.CopyMode);
end;

end.
