unit uPaint2Raster;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics,uPaint2Object,dialogs;
  
type
  TChangeValue = procedure() of object;
  
  TPaint2Colors = class(TPersistent)
  private
    fBrush:Tbrush;
    fPen:TPen;
  public
    constructor Create;
  published
//    property Brush:TBrush read fBrush write fBrush;
    property Pen:TPen read fPen write fPen;
  end;

  TPaint2Raster = class(TPersistent)
  private
    fSizeChange:Boolean;
    poldBrush:TBrush;
    poldPen:Tpen;
    fhColor,fvColor:TPaint2Colors;
    fVisible:Boolean;
    frx,fry,oldx,oldy,oldw,oldh:Integer;
    oldbuffer:TBitmap;
    function GetIndex(index:Integer):Integer;
    procedure SetIndex(Index,value:Integer);
    procedure SetVisible(Value:Boolean);
    function getVisible:Boolean;
    procedure SetSizeChange(value:Boolean);
    function GetSizeChange:Boolean;
  public
    onChangeValue:TChangeValue;

    procedure Draw(x,y,w,h:Integer; buffer:TBitMap; oldpen:TPen; var oldBrush:Tbrush);
    constructor Create;

  published
    property Visible:Boolean read GetVisible write SetVisible;
    property hColor:Tpaint2Colors read fhColor write fhColor;
    property vColor:Tpaint2Colors read fvColor write fvColor;
    property rx:Integer index 0 read GetIndex write SetIndex;
    property ry:Integer index 1 read GetIndex write SetIndex;
    property AutoObjectSizeChange:Boolean read GetSizeChange write SetSizeChange;
  end;



implementation


procedure TPaint2Raster.Draw(x,y,w,h:Integer; buffer:TBitMap;oldpen:TPen; var oldBrush:Tbrush);
var
  px,py:Integer;
begin
  if visible = true then begin
    oldx:=x; oldy:=y; oldw:=w; oldh:=h;
    if buffer <> nil then
      oldbuffer:=buffer
    else
      buffer:=oldBuffer;
      
    poldpen.Assign(oldpen); poldBrush.Assign(oldBrush);
  
    if rx = 0 then rx:=16;
    if ry = 0 then ry:=16;

    px:=0; py:=y;
    // fuer horzizontale linen(die brush und pen werte festlegen)
    buffer.canvas.pen.Assign(fhColor.pen);
    for px:=1 to round((h-y) / ry) do begin
      buffer.canvas.MoveTo(x,py);
      buffer.canvas.LineTo(w,py);
      inc(py,ry+fvColor.pen.Width);
    end;

    // fuer vertikale linen(die brush und pen werte festlegen)
    buffer.canvas.pen.Assign(fvColor.pen);
    for py:=1 to round((w-x) / rx) do begin
      buffer.canvas.MoveTo(x,y);
      buffer.canvas.LineTo(x,h);
      inc(x,rx+fhColor.pen.Width);
    end;
  end; // visible = true

    // Werte wieder zuruecksetzen
   buffer.canvas.brush.Assign(oldBrush); buffer.canvas.pen.Assign(oldPen);
end;

constructor TPaint2Raster.Create;
begin
  fhColor:=Tpaint2Colors.Create; fvColor:=Tpaint2Colors.Create;
  fhColor.Pen.color:=clRed;

  poldBrush:=TBrush.Create;poldPen:=Tpen.Create;

  oldbuffer:=tbitmap.create;

  frx:=16; frx:=16; oldx:=0; oldy:=0; oldw:=0; oldh:=0;
  
end;

function TPaint2Raster.GetIndex(index:Integer):Integer;
begin
  if index = 0 then result:=frx;
  if index = 1 then result:=fry;
end;

procedure TPaint2Raster.SetIndex(Index,value:Integer);
begin
  if index = 0 then frx:=value;
  if index = 1 then fry:=value;
end;



constructor TPaint2Colors.Create;
begin
  fbrush:=TBrush.Create; fPen:=TPen.Create;
end;


procedure TPaint2Raster.SetVisible(Value:Boolean);
begin
  fVisible:=value;
  if value = true then begin
    Draw(oldx,oldy,oldw,oldh,oldbuffer,poldpen,poldbrush);
    if Assigned(onChangeValue) = true then
     onChangeValue;

  end;
  
end;

function TPaint2Raster.getVisible:Boolean;
begin
  result:=fVisible;
end;

procedure TPaint2Raster.SetSizeChange(value:Boolean);
begin
  fSizeChange:=value;
end;

function TPaint2Raster.GetSizeChange:Boolean;
begin
  result:=fSizeChange;
end;

end.

