unit ubrush;

{$MODE Delphi}

interface

uses
  LCLIntf, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, LResources, ColorBox,vkeys;

type
  Tfbrush = class(TForm)
    Label1: TLabel;
    ColorBox1: TColorBox;
    Label2: TLabel;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ComboBox1: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private-Deklarationen }
  public
    isbrushStyl:Boolean;
    procedure SetBrushStyl(Value:Boolean);
    { Public-Deklarationen }
  end;

var
  fbrush: Tfbrush;

implementation


procedure Tfbrush.SetBrushStyl(Value:Boolean);
var
  i:integer;
begin
  comboBox1.Clear;
  isbrushStyl:=Value;
  if value = true then begin
    Caption:='Hintergrund';
    for i:=0 to 7 do
      Combobox1.items.add(intTostr(i));
  end
  else begin
    Caption:='Fordergrund';
    for i:=0 to 6 do
      Combobox1.items.add(intTostr(i));
  end;
end;

procedure Tfbrush.FormShow(Sender: TObject);
begin
  tag:=0;
end;

procedure Tfbrush.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_return then BitBtn1Click(Sender);
  if key = vk_escape then BitBtn2Click(Sender);
end;

procedure Tfbrush.BitBtn1Click(Sender: TObject);
begin
  tag:=1;
  close
end;

procedure Tfbrush.BitBtn2Click(Sender: TObject);
begin
  tag:=2;
  close
end;

procedure Tfbrush.FormCreate(Sender: TObject);
begin
  SetBrushStyl(true);
end;

procedure Tfbrush.ComboBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
 xofs,yofs,breite:integer;
begin
  if isbrushStyl = True then begin
     with ComboBox1.Canvas do begin
          fillrect(rect);
          brush.style:=tBrushstyle(index);
          if index <> 1 then brush.color:= clblack else brush.color:=clWhite;
          rectangle(Rect.left,Rect.top,Rect.right,Rect.bottom);
     end;
  end
  else begin
     breite := Rect.right-Rect.left-20; //stellt in ComboBox1 Linienarten grafisch dar
     xofs   := Rect.left+10;
     yofs   := Rect.top;
     with ComboBox1.Canvas do begin
          fillrect(rect);
          pen.style:=TPenStyle(index);
          moveto(xofs,yofs+8);lineto(xofs+breite,yofs+8);
     end;

  end;

end;

initialization
  {$i ubrush.lrs}
  {$i ubrush.lrs}
  {$i ubrush.lrs}

end.
