unit uListe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics,Contnrs,uPaint2Obj,upaint2ObjBase,comctrls,
  StdCtrls,LCLIntf,RTTIGrids,dialogs,uextras,uPaint2Object,inifiles,tools,lcltype,controls,uPaint2Raster;
  
const
  nul1 = 0;
  Backgrund      = -2;
  None           = -1;
  alt_Line       = 0;
  alt_Dreieck    = 1;
  alt_Vireck     = 2;
  alt_kreis      = 3;
  alt_Text       = 4;
  alt_Poligon    = 5;
  alt_agr        = 6; // abgerundes Reckeck

  Neu_Line       = 30;
  Neu_Dreieck    = 31;
  Neu_Vieck      = 32;
  Neu_Kreis      = 33;
  Neu_Text       = 34;
  Neu_Poligon    = 35;
  Neu_agr        = 36; // abgerundes Recheck

  Allgemein_cf   = 60; // Farbfller;
  Allgemein_cp   = 61; // Farbfinder

type

  { TmyList }
  TDocumentList = class // unit2 auch
    FileName:TFileName;
    isShift,Adding:Boolean;
    objlist:TObjectList;
    Gepackt,Versch,userdefniert:Boolean;
    isMod:Boolean;
    bg:Tbg;
    sf:TRect;
  end;


  TmyList = class
  private
    fBuffer:TBitmap;
    fselectObject:TPaint2BasesObj;
    fVt:TTIPropertyGrid;
    fDocumentindex:Integer;
    function GetSelect: TPaint2BasesObj;
    procedure SetSelect(const AValue: TPaint2BasesObj);
    procedure SetSelectObject(const AValue: TPaint2BasesObj);
    procedure SetDocumentindex(value:Integer);
    function getdocumentindex:Integer;
  public
    isObjMove:Boolean;
//    Documentlist[documentindex].objlist:TObjectList;
    usrListBox:TListBox;
    oldItemindex:Integer;
    itemindex:integer;
//    Documentindex:Integer;
    Documentlist:array of TDocumentList;
    AktivDocument:TDocumentList;
    property Documentindex:Integer read getdocumentindex write SetDocumentindex;
    
    procedure SetPointDraq(index:Integer);
    property selobject:TPaint2BasesObj read GetSelect write SetSelectObject;

    function GetItemIndex(x,y:Integer;Obj1:TObjectList;state:TShiftState):Integer;

    function GetPaint2Obj(index:Integer):TPaint2BasesObj;
    function DeleteObject(index:integer):Integer;
    function GetSelObject:Integer;
    function AddObj(toolindex:Integer):TPaint2Object;

    procedure SetVisibleObj(index:Integer; value:Boolean);
    procedure SetBrush(Index:Integer; value:TBrush);
    procedure SetPen(Index:Integer; value:TPen);
    constructor Create(oi:TTIPropertyGrid;buffer:tBitmap);
    function GetName(objtyp:Integer):Integer;
    procedure Clear;
    procedure SetSelObj(value:Boolean);
    procedure UpdatetOI;
    procedure SaveToFile(FileName:TFileName);
    procedure LoadFromFile(FileName:TFileName);
    procedure MoveObj(x,y:Integer; oldpos:TPoint);
    procedure ChangeObjSize(x,y:Integer;shift:TShiftState;Adding:Boolean);
    procedure SetFocusAllObj(index:Integer);
    procedure SaveToAllFile(FileName:TFileName;pagecontrol:TPagecontrol);
    procedure FreeDocumentindex;
    procedure loadFiles(wert:Boolean;Dialog:TOpenDialog;pc:TPageControl);
  published
  end;


implementation

{ TmyList }
uses upaint2main,unit2;


function GetLineClickA(x1,y1,x2,y2,x3,y3:Integer):Boolean;
var
// Gegeben
  A: TPoint; // Punkt der Geraden
  B: TPoint; // Punkt der Geraden
  P: TPoint; // Punkt des Mausklicks
// errechnete Werte
  g: TPoint; // Richtungsvektor
  n: TPoint; // Normalvektor
  d: Integer; // d = a*x + b*y

  HNF: Double;

begin
  a.x:=x1; a.y:=y1;
  b.x:=x2; b.y:=y2;
  p.x:=x3; p.y:=y3;
  
  g := Point(B.X - A.X, B.Y - A.Y);
  n := Point(g.Y, -g.X);
  d := n.X * A.X + n.Y * A.Y;

  HNF := Abs((n.X * P.X + n.Y * P.Y - d) / Sqrt(n.X * n.X + n.Y * n.Y));

  // hier Wert anpassen

  if HNF < 5 then
    result:=True
  else
    result:=false;
end;

function GetLineClick(x1,y1,x2,y2,x3,y3:Integer):Boolean;
var
  dxa,dya,dxb,dyb,x,y,x4,y4,dist:Integer;
begin
  dxa:=x2-x1;
  dya:=y2-y1;

  x4:=x3+(y2-y1);
  y4:=y3-(x2-x1);

  dxb:=x4-x3;
  dyb:=y4-y3;

  x:=round(((y3-y1)*dxa*dxb+x1*dya*dxb-x3*dyb*dxa)/(dya*dxb-dyb*dxa));
  if abs(dxa)>abs(dxb) then
    y:=round(((x-x1)*dya+y1*dxa)/dxa)
  else
    y:=round(((x-x3)*dyb+y3*dxb)/dxb);
  dist:=round(sqrt(sqr(x3-x)+sqr(y3-y)));
  
  if not((((x<=x1)and(x>=x2))or((x>=x1)and(x<=x2))) and (((y<=y1)and(y>=y2))or((y>=y1)and(y<=y2)))) then
    result:=false
  else
    result:=true;
end;

function tmylist.getdocumentindex:Integer;
begin
  result:=fDocumentindex;
end;

procedure TmyList.SetDocumentindex(value:Integer);
begin
  if value > - 1 then begin
    AktivDocument:=Documentlist[value];
  end;
  fDocumentindex:=Value;
end;

procedure TmyList.SetFocusAllObj(index:Integer);
var
  i:Integer;
begin
  if index = -2 then begin
    if OldItemindex > -1 then
      index:= oldItemindex
    else
      index:=itemindex;
  end;
  
  for i:=0 to AktivDocument.objlist.count-1 do begin
    if i = index then begin
      if itemindex <> olditemindex then
        oldItemindex:=itemindex;
      itemindex:=i;
      TPaint2BasesObj(AktivDocument.objlist[i]).isfocus:=True;
      selobject:=TPaint2BasesObj(AktivDocument.objlist[i]);
    end
    else
      TPaint2BasesObj(AktivDocument.objlist[i]).isfocus:=False
  end;
end; // SetFocusAllObj


procedure TmyList.SaveToAllFile(FileName:TFileName;pagecontrol:TPagecontrol);
var
  i,di:Integer;
  Daten:TStringList;
begin
//  if Documentlist[documentindex].objlist.count > 0 then begin
  if Filename <> '' then
  Form4.FileNameEdit1.text:=Filename;
  Form4.Panel5.Visible:=True;
  form4.AddDocumentlistView(Documentlist);
  Form4.ShowModal;
  if Form4.tag = 1 then begin // es wurde auf ok geklickt;
  // Werte werden übernommen wie z.b. ob es gepackt oder verschlüsselt werden soll
    Daten:=TStringList.Create;
    for di:=0 to high(documentlist) do begin
      daten.clear;
      Documentlist[di].bg.Save(Daten,nil);
      Documentlist[di].isMod:=false;
      for i:=0 to Documentlist[di].objlist.count-1 do begin
        Documentlist[di].FileName:=Form4.listview2.items[di].Caption;

        with TPaint2BasesObj(Documentlist[di].objlist[i]) do begin
          saveinfo.gruppenindex:=StrToint(Form4.ListView1.items[i].SubItems[0]);
          saveinfo.gepackt:=StrToBool(Form4.ListView1.items[i].SubItems[1]);
          saveinfo.versch:=StrToBool(Form4.ListView1.items[i].SubItems[2]);

          TPaint2BasesObj(Documentlist[di].objlist[i]).Save(Daten,nil);
        end;
      end;

        if Form4.CheckBox7.Checked = False then begin
          Daten.SaveToFile(form4.FileNameEdit2.text+Documentlist[di].FileName);
      end;
    end;
  end;
//  end // if Documentlist[documentindex].objlist.count > -1
//  else
//    Showmessage('Es sind keine Objekte im Document');

end;

procedure TmyList.SaveToFile(FileName:TFileName);
var
  i:Integer;
  Daten:TStringList;
begin
  if High(Documentlist) = 0 then begin
    if AktivDocument.objlist.count > 0 then begin
      if Filename <> '' then Form4.FileNameEdit1.text:=Filename;
      Form4.Panel5.Visible:=False;
      for i:=0 to AktivDocument.objlist.count-1 do begin
        with TPaint2BasesObj(AktivDocument.objlist[i]) do
          form4.AddListView(Name,saveinfo.gruppenindex,saveinfo.gepackt,saveinfo.versch);

      end;
    
      Form4.ShowModal;
      Filename:=Form4.FileNameEdit1.text;
      if Form4.tag = 1 then begin // es wurde auf ok geklickt;
      // Werte werden übernommen wie z.b. ob es gepackt oder verschlüsselt werden soll
        Daten:=TStringList.Create;
//        bg.Save(Daten,nil);

        for i:=0 to AktivDocument.objlist.count-1 do begin
          with TPaint2BasesObj(AktivDocument.objlist[i]) do begin
            saveinfo.gruppenindex:=StrToint(Form4.ListView1.items[i].SubItems[0]);
            saveinfo.gepackt:=StrToBool(Form4.ListView1.items[i].SubItems[1]);
            saveinfo.versch:=StrToBool(Form4.ListView1.items[i].SubItems[1]);
            TPaint2BasesObj(AktivDocument.objlist[i]).Save(Daten,nil);
          end;
        end;
      end;
      AktivDocument.isMod:=False;
    end // if Documentlist[documentindex].objlist.count > -1
    else
      Showmessage('Es sind keine Objekte im Document');
  end
  else
    SaveToAllFile(FileName,nil)
    
end;

procedure TmyList.LoadFromFile(FileName:TFileName);
var
  inifile:inifiles.TIniFile;
  i,typ:Integer;
  Daten,Daten2:TStringList;
  op:TPaint2BasesObj;
  str:String;
begin
  if FileExists(Filename) = True then begin
    typ:=-1;
    iniFile:=TIniFile.Create(Filename);
    Daten:=TStringList.Create;
    inifile.ReadSections(Daten);
    daten2:=TStringlist.Create;
    for i:=0 to Daten.Count-1 do begin
      inifile.ReadSectionRaw(Daten[i],daten2);
      str:=GetToken(daten2.Strings[3],'=',2);
      if str <> '-2' then
        typ:=StrToInt(str)
      else
        typ:=-2;

      if typ <> -2 then begin
        upaint2main.paint2.AddObj(typ,20,20,20,20);
//        AddObj(typ);
        selobject.load(Daten2,nil);
        selobject.isfocus:=false;
        selobject.pointDrawDown:=-1;selobject.pointDrawMove:=-1;
      end
      else begin
//        bg.load(Daten2,nil)
      end;

    end;
  end;

end;

function TmyList.GetItemIndex(x,y:Integer;Obj1:TObjectList;state:TShiftState):Integer;
var
  i,pIndex:Integer;
  r:TRect;
  Region:     THandle;
  obj:TObjectList;
begin
  pIndex:=-1;
  if obj1 = nil then obj:=AktivDocument.objlist;
  if oldItemindex <> itemindex then begin
    if selobject <> NIL then selobject.isfocus:=false;
  end;

  for i:=0 to obj.count-1 do begin
//    ShowMEssage(IntTostr(AktivDocument.objlist.count) + '\' + Inttostr(i));
    with TPaint2BasesObj(AktivDocument.objlist.items[i]) do begin
      isfocus:=false;
      if obj.Items[i] is TLine = false then begin
        r.left:=position.x; r.top:=position.y; r.Right:=size.x;r.Bottom:=size.y;
        if PtInRect(r,point(x,y)) = true then
          pindex:=i;
      end
      else begin
      if (GetLineClickA(position.x,position.y,size.x,size.y,x,y) = true) then
         pindex:=i;
      end;
    end;
  end;
  if pindex > -1 then begin
    selobject:=TPaint2BasesObj(AktivDocument.objlist.items[pindex]);
    selobject.isfocus:=true;
    if oldItemindex <> itemindex then
    oldItemindex:=itemindex;
    itemindex:=pIndex;

  end;
  writeLn(IntTostr(Pindex));

  result:=Pindex;
  if pindex > -1 then begin
    if ssshift in state then
    TPaint2BasesObj(AktivDocument.objlist.items[pindex]).Sel:=True;
  end
  else begin
    SetSelObj(false);
    selobject:=AktivDocument.bg;
  end;
  Region:=0;
//  Region
end;

function TmyList.GetName(objtyp:Integer):Integer;
var
  i,z:Integer;
begin
  z:=-1;
  if objtyp < 80 then begin
    for i:=0 to AktivDocument.objlist.count -1 do begin
      if TPaint2BasesObj(AktivDocument.objlist.items[i]).Typ = objtyp then
        inc(z)
    end;
  end
  else begin
    for i:=0 to usrListBox.items.count -1 do begin
      if usrListBox.Items.Objects[i] is tImageListB then
        inc(z)
    end;

  end;
  
  result:=z+1;
end; // GetName

function TmyList.GetSelect: TPaint2BasesObj;
begin
  result:=fselectObject;
end;

procedure TmyList.SetSelect(const AValue: TPaint2BasesObj);
begin
  fselectObject:=AValue;
  oldItemindex:=-1;
end;

function TmyList.GetPaint2Obj(index: Integer): TPaint2BasesObj;
begin
  if index > -1 then
    result:=TPaint2BasesObj(AktivDocument.objlist.items[index])
  else
    result:=nil;
end;

procedure TmyList.SetSelectObject(const AValue: TPaint2BasesObj);
begin
  fselectObject:=AValue;
  if AValue <> NIL then begin
    if fVt <> NIL then
    fVt.TIObject:=Avalue;
  end
  else begin
    if (Documentindex > -1) and (high(Documentlist) >=0) then begin
      if AktivDocument.bg <> NIL then begin
      if fVt <> NIL then
        fVt.TIObject:=AktivDocument.bg;
      end;
    end;
  end;
end;

function TmyList.DeleteObject(index: integer): Integer;
var
  i:Integer;
begin
  if index = -2 then begin
    for i:=AktivDocument.objlist.Count-1 downto 0 do begin
      if TPaint2BasesObj(AktivDocument.objlist.Items[i]).Sel = true then begin
        AktivDocument.objlist.Delete(i);
        if Assigned(paint2.onDeleteObj) then paint2.onDeleteObj(i);
      end;
    end;
  end;
  itemindex:=-1; oldItemindex:=-1;
end; // DeleteObject

function TmyList.GetSelObject: Integer;
var
  i,t:Integer;
begin
  t:=0;
  for i:=0 to AktivDocument.objlist.count-1 do begin
    if TPaint2BasesObj(AktivDocument.objlist[i]).Sel = true then
      inc(t)
  end;
  result:=t;
end; // GetSelObject

function TmyList.AddObj(toolindex:Integer): TPaint2Object;
var
  paint2obj:TPaint2Object;
begin
  if (oldItemindex > -1) and (AktivDocument.objlist.count > 0 ) and (oldItemindex <=AktivDocument.objlist.Count-1) then begin
    TPaint2BasesObj(AktivDocument.objlist[oldItemindex]).isfocus:=false;
  end;
    
  fBuffer.Canvas.Brush.color:=clBlue;
  paint2obj:=nil;
  if toolindex = alt_Vireck then paint2obj:=TRectEck.Create(fBuffer);
  if toolindex = alt_kreis then paint2obj:=TKreis.Create(fBuffer);
  if toolindex = alt_Line then  paint2obj:=TLine.Create(fBuffer);

   if toolindex = alt_agr then  paint2obj:=troundrec.Create(fBuffer);

  if toolindex = Extras_ImageListB then begin
    paint2obj:=tImageListB.Create;
  end;
  

  if toolindex < 80 then begin
    if paint2obj <> NIL then begin
      AktivDocument.objlist.Add(paint2obj);
      result:=TPaint2Object(AktivDocument.objlist[Documentlist[documentindex].objlist.Count-1]);
      selobject:=TPaint2BasesObj(Documentlist[documentindex].objlist[Documentlist[documentindex].objlist.Count-1]);
     itemindex:=AktivDocument.objlist.Count-1;
   end
    else
      result:=nil;
  end
  else begin
    usrListBox.Items.AddObject(paint2obj.Name,tImageListB(paint2obj));
    result:=TPaint2Object(usrListBox.Items.Objects[usrListBox.items.Count-1]);
  end;

  if Documentindex > -1 then
    AktivDocument.isMod:=true;
end; // AddObj

procedure TmyList.SetVisibleObj(index: Integer; value: Boolean);
begin

end; // SetVisibleObj

procedure TmyList.SetBrush(Index: Integer; value: TBrush);
begin

end; // SetBrush

procedure TmyList.SetPen(Index: Integer; value: TPen);
begin

end; // SetPen

constructor TmyList.Create(oi:TTIPropertyGrid;buffer:TBitmap);
begin
//  FensterR; // ist der gesmmate scrollbeirech
//  Sichtfenster; // ist nur der teil der angezeigt wird
  SetLength(Documentlist,0);fbuffer:=buffer;
  itemindex:=-1; fVt:=oi; selobject:=nil;
  fDocumentindex:=-1;
//  Documentindex:=-1;
end;

procedure Tmylist.Clear;
begin

end;

procedure Tmylist.SetSelObj(value:Boolean);
var
  i:Integer;
begin
  if (oldItemindex > -1) and (AktivDocument.objlist.count > 0 ) and (oldItemindex <= AktivDocument.objlist.count-1) then
    TPaint2BasesObj(AktivDocument.objlist[oldItemindex]).isfocus:=false;

  for i:=0 to AktivDocument.objlist.Count-1 do begin
    TPaint2BasesObj(AktivDocument.objlist.Items[i]).Sel:=value;
  end;
//  itemindex:=-1;
end;

procedure Tmylist.UpdatetOI;
begin
  if (selobject <> NIL) and (fvt.TIObject <> NIL) then begin
    fvt.TIObject:=selobject;
    fvt.PropEditLookupRootChange;
    fvt.RefreshPropertyValues;
    fvt.Clear;

    writeln('test');
    fvt.Update;
    fvt.Invalidate;
    fvt.Refresh;

  end;

end;

procedure Tmylist.MoveObj(x,y:Integer;oldpos:TPoint);
var
  i,dx,dy:Integer;
begin
  dx:=x-oldpos.x;
  dy:=Y-oldpos.y;

  for i:=0 to AktivDocument.objlist.Count-1 do begin
    if (TPaint2BasesObj(AktivDocument.objlist[i]).fest = false) and (TPaint2BasesObj(AktivDocument.objlist[i]).Visible = true) then begin
      if (TPaint2BasesObj(AktivDocument.objlist[i]).Sel = true) or(itemindex = i) then begin
        with TPaint2BasesObj(AktivDocument.objlist[i]) do begin
          position:=pointTOTPoint2(dx+(Position.x),dy+(Position.y));
          size:=pointTOTPoint2((x-oldpos.X+size.X),(y-oldpos.Y+size.y));
          isObjMove:=True;
        end;
      end;
    end;
  end;

end;

procedure TMylist.SetPointDraq(index:Integer);
begin
  // ndert den Mauszeiger entsprechend des Indexes
  if itemindex > -1 then begin
    if index > -1 then
    paint2.invalidate;
{    case index of
      0:c. Cursor:=crSizeNWSE;
      1:c.Cursor:=crSizeNESW;
      2:c.Cursor:=crSizeNWSE;
      3:c.Cursor:=crSizeNESW;
      4:c.Cursor:=crSizeNS;
      5:c.Cursor:=crSizeNS;
      6:c.Cursor:=crSizeWE;
      7:c.Cursor:=crSizeWE
      else
        c.Cursor:=crDefault
    end;
    ReleaseCapture;}
  end;
end;

procedure Tmylist.ChangeObjSize(x,y:Integer;shift:TShiftState;Adding:Boolean);
begin

  if (itemindex > -1) and (selobject <> NIL) then begin
      if isObjMove = false then
      SetPointDraq(selobject.pointDrawMove);
      
    if (adding = false) then begin
      if (ssCtrl in shift) and ((ssLeft in Shift) or (ssRight in Shift)) then
        selobject.ShiftFunc(x,y)
      else
        selobject.ChangeSizeObj(x,y);
    end;

    if (isObjMove = false) then selobject.SetSizePointIndex(x,y,shift);
  end;
  
end;

procedure Tmylist.FreeDocumentindex;
var
  i,m:Integer;
  w:Word;
begin
  if Documentindex > -1 then begin

    if AktivDocument.isMod then begin
      w:=MessageDlg('Seite speichern...','Seite wurde noch nicht gespeichert !',mtWarning,mbYesNoCancel,0);

      if w = mrYes then
        if Documentindex > -1 then
          SaveToFile(AktivDocument.FileName);
      if w = mrCancel then exit;
    end;
    
    AktivDocument.objlist.Clear;
    AktivDocument.objlist.Destroy;
    for i:=Documentindex to Length(Documentlist)-1 do begin
      if i + 1 <= Length(Documentlist)-1 then
        Documentlist[i]:=Documentlist[i+1];
    end;
    SetLength(Documentlist,Length(Documentlist)-1);
    fVt.TIObject:=AktivDocument.bg;
  end;
end;

procedure Tmylist.loadFiles(wert:Boolean;Dialog:TOpenDialog;pc:TPageControl);
var
  i:Integer;
begin
  if Dialog.Execute then begin
    for i:=0 to Dialog.Files.count-1 do begin
      if wert = True then begin
        AktivDocument.FileName:=Dialog.Files[i];
        paint2.AddDocument(false,pc,Dialog.Files[i]);
        AktivDocument.isMod:=false;
      end;
      paint2.isload:=True;
      paint2.LoadFromFile(Dialog.Files[i]);
      //pc.ActivePage.Caption:=ExtractFileName(AktivDocument.FileName);
      AktivDocument.isMod:=false;

    end;
  end;
  paint2.isload:=false;
end;

end.

